import { serializeWith } from 'serde/ser'
import { Deserialize } from 'serde/de'
import { JSONSerializer } from './ser'
import { JSONDeserializer } from './de'

export function toString(value: any): string {
  const serializer = new JSONSerializer()
  serializeWith(serializer, value)
  return serializer.output
}

export function fromString<T, D extends Deserialize<T>>(value: string, into: D): T {
  const deserializer = JSONDeserializer.fromString(value)
  return into.deserialize(deserializer)
}

